



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++类的大小计算汇总</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++类的大小计算汇总</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 11:40:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　C++中类涉及到虚函数成员、静态成员、虚继承、多继承、空类等。</p>
<p>　　类，作为一种类型定义，是没有大小可言的。</p>
<p>　　类的大小，指的是类的对象所占的大小。因此，用sizeof对一个类型名操作，得到的是具有该类型实体的大小。</p>
<ul><li><strong>类大小的计算，遵循结构体的对齐原则；</strong></li>
<li><strong>类的大小，与普通数据成员有关，与成员函数和静态成员无关。即普通成员函数、静态成员函数、静态数据成员、静态常量数据成员，均对类的大小无影响；</strong></li>
<li><strong>虚函数对类的大小有影响，是因为虚函数表指针带来的影响；</strong></li>
<li><strong>虚继承对类的大小有影响，是因为虚基表指针带来的影响；</strong></li>
<li><strong>静态数据成员之所以不计算在类的对象大小内，是因为类的静态数据成员被该类所有的对象所共享，并不属于具体哪个对象，静态数据成员定义在内存的全局区；</strong></li>
<li><strong>空类的大小（<strong>类的大小为1</strong>），以及含有虚函数，虚继承，多继承是特殊情况；</strong></li>
<li><strong>计算涉及到内置类型的大小，以下所述结果是在64位gcc编译器下得到（int大小为4，指针大小为8）；</strong></li></ul>
<p><strong>一、简单情况的计算</strong></p>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;<br />
using namespace std;

class base<br />
{<br />
    public:<br />
    base()=default;<br />
    ~base()=default;<br />
    private:<br />
    static int a;<br />
    int b;<br />
    char c;

};

int main()<br />
{<br />
    base obj;<br />
    cout&lt;&lt;sizeof(obj)&lt;&lt;endl;<br />
}
</pre>
</div>
<p>　　计算结果：8（静态变量a不计算在对象的大小内，由于字节对齐，结果为4+4=8）。</p>
<p>　　</p>
<p><strong>二、空类的大小</strong></p>
<p>　　C++的空类是指这个类不带任何数据，即类中没有非静态(non-static)数据成员变量，没有虚函数(virtual function)，也没有虚基类(virtual base class)。</p>
<p>　　直观地看，空类对象不使用任何空间，因为没有任何隶属对象的数据需要存储。然而，C++标准规定，凡是一个独立的(非附属)对象都必须具有非零大小。换句话说，c++空类的大小不为0 。</p>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
using namespace std;

class NoMembers<br />
{<br />
};

int main()<br />
{<br />
    NoMembers n;<br />
    cout &lt;&lt; sizeof(n) &lt;&lt; endl;<br />
}
</pre>
</div>
<p>　　计算结果1。</p>
<p>　　C++标准指出，不允许一个对象（当然包括类对象）的大小为0，不同的对象不能具有相同的地址。</p>
<p>　　这是由于：</p>
<ul><li>new需要分配不同的内存地址，不能分配内存大小为0的空间；</li>
<li>避免除以 sizeof(T)时得到除以0错误；</li></ul>
<p>　　故使用一个字节来区分空类。</p>
<p>　　但是，有两种情况值得我们注意</p>
<p>　　第一种情况，空类的继承：</p>
<p>　　当派生类继承空类后，派生类如果有自己的数据成员，而空基类的一个字节并不会加到派生类中去。</p>
<p><em>　　</em></p>
<div>
<pre class="prettyprint linenums">class Empty {};<br />
struct D : public Empty { int a;};
</pre>
</div>
<p>　　sizeof(D)为4。</p>
<p>　　第二种情况，一个类包含一个空类对象数据成员：</p>
<p>　　</p>
<div>
<pre class="prettyprint linenums">class Empty {};<br />
class HoldsAnInt {<br />
    int x;<br />
    Empty e;<br />
};
</pre>
</div>
<p>　　sizeof(HoldsAnInt)为8。</p>
<p>　　在这种情况下，空类的1字节是会被计算进去的。而又由于字节对齐的原则，所以结果为4+4=8。</p>
<p>　　继承空类的派生类，如果派生类也为空类，大小也都为1。</p>
<p>　　</p>
<p><strong>三、含有虚函数成员的类</strong></p>
<p>　　虚函数（Virtual Function）是通过一张虚函数表（Virtual Table）来实现的。编译器必需要保证虚函数表的指针存在于对象实例中最前面的位置（这是为了保证正确取到虚函数的偏移量）。</p>
<p>　　每当创建一个包含有虚函数的类或从包含有虚函数的类派生一个类时，编译器就会为这个类创建一个虚函数表（VTABLE）保存该类所有虚函数的地址，其实这个VTABLE的作用就是保存自己类中所有虚函数的地址，可以把VTABLE形象地看成一个函数指针数组，这个数组的每个元素存放的就是虚函数的地址。在每个带有虚函数的类中，编译器秘密地置入一指针，称为vpointer（缩写为VPTR），指向这个对象的VTABLE。 当构造该派生类对象时，其成员VPTR被初始化指向该派生类的VTABLE。所以可以认为VTABLE是该类的所有对象共有的，在定义该类时被初始化；而VPTR则是每个类对象都有独立一份的，且在该类对象被构造时被初始化。</p>
<div>
<pre class="prettyprint linenums">class Base {

public:

virtual void f() { cout &lt;&lt; "Base::f" &lt;&lt; endl; }

virtual void g() { cout &lt;&lt; "Base::g" &lt;&lt; endl; }

virtual void h() { cout &lt;&lt; "Base::h" &lt;&lt; endl; }

};
</pre>
</div>
<p>　　当定一个Base类的实例b时，其b中成员的存放如下：<strong>　　</strong></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1166839/201901/1166839-20190113151434196-1162019173.png" /></p>
<p>　　指向虚函数表的指针在对象b的最前面。</p>
<p>　　虚函数表的最后多加了一个结点，这是虚函数表的结束结点，就像字符串的结束符&rdquo;\0&rdquo;一样，其标志了虚函数表的结束。这个结束标志的值在不同的编译器下是不同的。在Visual Studio下，这个值是NULL。而在linux下，如果这个值是1，表示还有下一个虚函数表，如果值是0，表示是最后一个虚函数表。</p>
<p>　　因为对象b中多了一个指向虚函数表的指针，而指针的sizeof是8，因此含有虚函数的类或实例最后的sizeof是实际的数据成员的sizeof加8。</p>
<div>
<pre class="prettyprint linenums">class Base {

public:

int a;

virtual void f() { cout &lt;&lt; "Base::f" &lt;&lt; endl; }

virtual void g() { cout &lt;&lt; "Base::g" &lt;&lt; endl; }

virtual void h() { cout &lt;&lt; "Base::h" &lt;&lt; endl; }<br />
}<br />&nbsp;</pre>
</div>
<p>　　sizeof(Base)为16（vptr指针的大小为8，又因为对象中还包含一个int变量，字节对齐得8+8=16）。</p>
<p><strong>四、基类含有虚函数的继承</strong></p>
<p>（1）在派生类中不对基类的虚函数进行覆盖，同时派生类中还拥有自己的虚函数，比如有如下的派生类：</p>
<div>
<pre class="prettyprint linenums">class Derived: public Base<br />
{

public:

virtual void f1() { cout &lt;&lt; "Derived::f1" &lt;&lt; endl; }

virtual void g1() { cout &lt;&lt; "Derived::g1" &lt;&lt; endl; }

virtual void h1() { cout &lt;&lt; "Derived::h1" &lt;&lt; endl; }

};
</pre>
</div>
<p>　　基类和派生类的关系如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1166839/201901/1166839-20190113153252033-752847341.png" /></p>
<p>　　当定义一个Derived的对象d后，其成员的存放如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1166839/201901/1166839-20190113155317054-328381814.png" /></p>
<p>　　可以发现：</p>
<p>　　1）虚函数按照其声明顺序放于表中。</p>
<p>　　2）基类的虚函数在派生类的虚函数前面。</p>
<p>　　此时基类和派生类的sizeof都是数据成员的大小+指针的大小8。</p>
<p>（2）在派生类中对基类的虚函数进行覆盖，假设有如下的派生类：</p>
<div>
<pre class="prettyprint linenums">class Derived: public Base<br />
{

public:

virtual void f() { cout &lt;&lt; "Derived::f" &lt;&lt; endl; }

virtual void g1() { cout &lt;&lt; "Derived::g1" &lt;&lt; endl; }

virtual void h1() { cout &lt;&lt; "Derived::h1" &lt;&lt; endl; }

};
</pre>
</div>
<p>　　基类和派生类之间的关系：其中基类的虚函数f在派生类中被覆盖了。　　</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1166839/201901/1166839-20190113154122215-787920244.png" /></p>
<p>　　当我们定义一个派生类对象d后，其d的成员存放为：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1166839/201901/1166839-20190113155047719-428774835.png" /></p>
<p>　　可以发现：</p>
<p>　　1）覆盖的f()函数被放到了虚表中原来基类虚函数的位置；</p>
<p>　　2）没有被覆盖的函数依旧；</p>
<p>　　3）派生类的大小仍是基类和派生类的非静态数据成员的大小+一个vptr指针的大小；</p>
<div>
<pre class="prettyprint linenums">Base *b = new Derive();<br />
b-&gt;f();
</pre>
</div>
<p>　　由b所指的内存中的虚函数表的f()的位置已经被Derive::f()函数地址所取代，于是在实际调用发生时，是Derive::f()被调用了。这就实现了多态。</p>
<p>（3）多继承：无虚函数覆盖&nbsp;<br />　　假设基类和派生类之间有如下关系：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1166839/201901/1166839-20190113155527002-1744402586.png" /></p>
<p>　　对于派生类实例中的虚函数表，是下面这个样子：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1166839/201901/1166839-20190113160012636-1631760678.png" /></p>
<p>　　可以看到：</p>
<p>　　1） 每个基类都有自己的虚表；</p>
<p>　　2） 派生类的成员函数被放到了第一个基类的表中（所谓第一个基类是按照声明顺序来判断的）；</p>
<p>　　由于每个基类都需要一个指针来指向其虚函数表，因此d的sizeof等于d的数据成员加上三个指针的大小。</p>
<p>（4）多重继承，含虚函数覆盖 ：<br />　　假设，基类和派生类又如下关系：派生类中覆盖了基类的虚函数f&nbsp;。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1166839/201901/1166839-20190113160647566-1502688121.png" /></p>
<p>　　可以看见，三个基类虚函数表中的f()的位置被替换成了派生类的函数指针。这样，就可以任一静态类型的基类类来指向派生类，并调用派生类的f()了。</p>
<div>
<pre class="prettyprint linenums">Derive d;

Base1 *b1 = &amp;d;

Base2 *b2 = &amp;d;

Base3 *b3 = &amp;d;

b1-&gt;f(); //Derive::f()

b2-&gt;f(); //Derive::f()

b3-&gt;f(); //Derive::f()

b1-&gt;g(); //Base1::g()

b2-&gt;g(); //Base2::g()

b3-&gt;g(); //Base3::g()
</pre>
</div>
<p>　　&nbsp;此情况派生类的大小也是类的所有非静态数据成员的大小+三个指针的大小。</p>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;<br />
using namespace std;

class A<br />
{<br />
};    

class B<br />
{<br />
    char ch;<br />
    virtual void func0()  {  }<br />
};   

class C<br />
{<br />
    char ch1;<br />
    char ch2;<br />
    virtual void func()  {  }<br />
    virtual void func1()  {  }<br />
};  

class D: public A, public C<br />
{<br />
    int d;<br />
    virtual void func()  {  }<br />
    virtual void func1()  {  }<br />
};<br />
class E: public B, public C<br />
{<br />
    int e;<br />
    virtual void func0()  {  }<br />
    virtual void func1()  {  }<br />
};  

int main(void)<br />
{<br />
    cout&lt;&lt;"A="&lt;&lt;sizeof(A)&lt;&lt;endl;    //result=1<br />
    cout&lt;&lt;"B="&lt;&lt;sizeof(B)&lt;&lt;endl;    //result=16<br />
    cout&lt;&lt;"C="&lt;&lt;sizeof(C)&lt;&lt;endl;    //result=16<br />
    cout&lt;&lt;"D="&lt;&lt;sizeof(D)&lt;&lt;endl;    //result=16<br />
    cout&lt;&lt;"E="&lt;&lt;sizeof(E)&lt;&lt;endl;    //result=32<br />
    return 0;<br />
}
</pre>
</div>
<p>　　结果分析:</p>
<p>　　1.A为空类，所以大小为1 ；</p>
<p>　　2.B的大小为char数据成员大小+vptr指针大小。由于字节对齐,大小为8+8=16 ；</p>
<p>　　3.C的大小为两个char数据成员大小+vptr指针大小。由于字节对齐，大小为8+8=16 ；</p>
<p>　　4.D为多继承派生类，由于D有数据成员，所以继承空类A时，空类A的大小1字节并没有计入当中，D继承C，此情况D只需要一个vptr指针，所以大小为数据成员加一个指针大小。由于字节对齐,大小为8+8=16 ；</p>
<p>　　5.E为多继承派生类，此情况为我们上面所讲的多重继承，含虚函数覆盖的情况。此时大小计算为数据成员的大小+2个基类虚函数表指针大小 ，考虑字节对齐，继承顺序B在先，B(8 + 1)，然后是C(8+1+1)，由于字节对齐，B得与C中最大值对齐，因此B+7变成16，再+C（10），得26，最后+E的其它成员+1，因为要整体对于最大值（8）对齐，因此补齐得32。（之前看到几篇博客这里解释得都有问题）<em><em><em><br /></em></em></em></p>
<h3>四.虚继承的情况</h3>
<p>　　对虚继承层次的对象的内存布局，在不同编译器实现有所区别。</p>
<p>　　在这里，只说一下在gcc编译器下，虚继承大小的计算。它在gcc下实现比较简单，不管是否虚继承，GCC都是将虚表指针在整个继承关系中共享的，不共享的是指向虚基类的指针。</p>
<div>
<pre class="prettyprint linenums">class A {

    int a;<br />　　virtual void myfuncA(){}<br />
};

class B:virtual public A{

    virtual void myfunB(){}

};

class C:virtual public A{

    virtual void myfunC(){}

};

class D:public B,public C{

    virtual void myfunD(){}

};
</pre>
</div>
<p>　　sizeof(A)=16，sizeof(B)=24，sizeof(C)=24，sizeof(D)=48；</p>
<p>　　A的大小为int大小加上虚表指针大小;</p>
<p>　　B，C中由于是虚继承，因此大小为int大小加指向虚基类的指针的大小。B,C虽然加入了自己的虚函数，但是虚表指针是和基类共享的，因此不会有自己的虚表指针，他们两个共用虚基类A的虚表指针。D由于B，C都是虚继承，其大小等于B+C）。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvvkwzq.html">机器学习之sklearn&mdash;&mdash;聚类</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zvw1d9.html">【原】iOS学习之UIStoryboardSegue解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2xp3l9.html">db2无法force掉备份连接的处理办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyg0kmq.html">一种table超出高度自动出滚动条的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93643g9.html">045医疗项目-模块四：采购单模块&mdash;采购单提交（Dao&comma;Service&comma;Action三层）</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq41grnq.html">李洪强漫谈iOS开发&lbrack;C语言-049&rsqb;-猜数字游戏</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7r7xk8.html">Leetcode 66 Plus One STL</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvvvgxq.html">hdu 1348 （凸包求周长）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnommv8.html">android 小方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmrdpz9.html">C&num;&period;Net 如何动态加载与卸载程序集（&period;dll或者&period;exe）2----通过应用程序域AppDomain加载和卸载程序集之后，如何再返回原来的主程序域</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmpyv69.html">自己写一个与startWith类似的判断方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1edvg8.html">HDOJ  2011  多项式求和</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x145m8.html">刚接触js不久，自己写的banner幻灯片效果。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvmv1yq.html">【转】app后端如何选择合适的数据库产品</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn13z738.html">C&num; IL 指令集</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzexzg8.html">c&plus;&plus;之模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg04e78.html">MySQL &amp;&num;183&semi; 引擎特性 &amp;&num;183&semi; InnoDB IO子系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/950drvz8.html">Swift数组字面量</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdgdl49.html">C语言之复杂链表的复制（图示详解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpxj539.html">day13  Python数据基本类型</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/960d74j9.html">Oracle课程档案，第四天</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj2n779.html">IO流实例</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy34o39.html">ubuntu下安装thrift</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj2v4r9.html">C和C指针小记&lpar;十五&rpar;-结构和联合</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvww628.html">微信小程序http 400问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllvp7kq.html">java框架之Struts2&lpar;1&rpar;-简介及入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllvp6xq.html">用php的chr和ord函数实现字符串和ASCII码互转</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w76vnq.html">插入排序（Python实现）</a>
			</li>
						<li><a href="https://www.batexi.com/a/960d4yn9.html">Py中查看数据类型【转载】</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w76kgq.html">Python openpyxl、pandas操作Excel方法简介与具体实例</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
